/*
 File: o2_linker_optssym.cpp
 Date and Time: Fri Jan 30 18:55:17 2015 
*/
#include "o2_linker_opts.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_o2_linker_opts;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Co2_linker_opts::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Ro2_lcl_opts_:{
       Ro2_lcl_opts* sym;
     if(re->rule_ == 0){
       sym = new Ro2_lcl_opts(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ro2_lcl_opts*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     sym->op();
     return;}
    case rhs1_Rextra_chaffe_:{
       Rextra_chaffe* sym;
     if(re->rule_ == 0){
       sym = new Rextra_chaffe(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rextra_chaffe*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rextra_chaffe_:{
       Rextra_chaffe* sym;
     if(re->rule_ == 0){
       sym = new Rextra_chaffe(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rextra_chaffe*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rws_k_:{
       Rws_k* sym;
     if(re->rule_ == 0){
       sym = new Rws_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rws_k_:{
       Rws_k* sym;
     if(re->rule_ == 0){
       sym = new Rws_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rws_k_s_:{
       Rws_k_s* sym;
     if(re->rule_ == 0){
       sym = new Rws_k_s(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k_s*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rws_k_s_:{
       Rws_k_s* sym;
     if(re->rule_ == 0){
       sym = new Rws_k_s(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws_k_s*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rws_:{
       Rws* sym;
     if(re->rule_ == 0){
       sym = new Rws(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rws*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs1_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rfile_:{
       Rfile* sym;
     if(re->rule_ == 0){
       sym = new Rfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr4();
     return;}
    default: return;
   }
}
